/****************************************************
 *  t\퐧䃉Cu@(lcdlib18.c)
 *  ֐͈ȉ
 *    delay_us()    ----- usecPʃfBC
 *    delay_ms()    ----- msecPʃfBC
 *    lcd_init()    ----- 
 *    lcd_cmd(cmd)  ----- R}ho
 *    lcd_data(chr) ----- P\o
 *    lcd_clear()   ----- S
 *    lcd_str(*string)--- ̏o
 *****************************************************/
#include "lcdlib18.h"

//////// f[^o̓Tu֐
void lcd_out(char code, char flag){
    // 4rbgo
    LCD_DATA = (LCD_DATA & 0x0F) | (code & 0xF0); 
    if (flag == 0)
        LCD_RS = 1;         // 
    else
        LCD_RS = 0;         // R}hf[^̏ꍇ
    Delay10TCYx(1);         // pulse width      
    LCD_E = 1;              // strobe out
    Delay10TCYx(1);         // pulse width
    LCD_E = 0;              // reset strobe
}
//////// P\֐
void lcd_data(char asci){
    lcd_out(asci, 0);       // ʂSrbgo
    lcd_out(asci<<4, 0);    // ʂSrbgo
    Delay10TCYx(50);        // 50sec҂
}
/////// R}ho͊֐
void lcd_cmd(char cmd){
    lcd_out(cmd, 1);        // ʂSrbgo
    lcd_out(cmd<<4, 1);     // ʂSrbgo
    if((cmd & 0x03) != 0)   // Clear homȅꍇ
        Delay10KTCYx(2);    // 2msec҂
    else
        Delay10TCYx(50);    // 50usec҂
}
/////// S֐
void lcd_clear(void){
    lcd_cmd(0x01);          // R}ho
    Delay10KTCYx(15);       // 15msec҂
}
/////// o͊֐
void lcd_str(char *str){
    while(*str != 0x00){    // ̏I蔻
        lcd_data(*str);     // Po
        str++;              // |C^{P
    }
}
/////// ֐
void lcd_init(void){
    Delay10KTCYx(50);
    lcd_out(0x03, 1);       // 8bit mode set
    Delay10KTCYx(5);
    lcd_out(0x03, 1);       // 8bit mode set
    Delay10KTCYx(1);
    lcd_out(0x03, 1);       // 8bit mode set
    Delay10KTCYx(1);
    lcd_out(0x02, 1);       // 4bit mode set
    Delay10KTCYx(1);
    lcd_cmd(0x2E);          // DL=0 4bit mode
    lcd_cmd(0x08);          // display off C=D=B=0
    lcd_cmd(0x0D);          // display on C=D=1 B=0
    lcd_cmd(0x06);          // entry I/D=1 S=0
    lcd_cmd(0x02);          // cursor home
}
